/*
 * CCUIS.cpp
 *
 *  Created on: Nov 25, 2009
 *      Author: jaxy
 */

#include <CCUIS.h>

using namespace std;
using namespace CCU;

Ice::CommunicatorPtr CraneI::_communicator;
Ice::ObjectAdapterPtr CraneI::_adapter;
// Command
string Server::_CommandName;
LIST Server::_CommandParameters;
bool Server::_commandChanged = false;
// State
State Server::_state;
bool Server::_stateChanged = false;

// CraneI
CraneI::CraneI(const WorkQueuePtr& workQueue) :
		_workQueue(workQueue)
{
}

// set Command
void CraneI::setCommand_async(const CCU::AMD_Crane_setCommandPtr& cb, const ::std::string& name, const ::CCU::LIST& parameters,const ::Ice::Current&) {
	/*cout << "setCommand - test!" << endl;
	Server::_CommandName = name;
	for(LIST::const_iterator it = parameters.begin(); it != parameters.end(); ++it) {
		Server::_CommandParameters.push_back(*it);
	}
	Server::_CommandChanged = true;*/
	_workQueue->add(cb,name,parameters);
	return;
};

// getCommandName
string
CraneI::getCommandName(const ::Ice::Current&) {
	string result;
	//if(Server::_CommandChanged) {
		result = Server::_CommandName;
		//Server::_CommandChanged = false;
	//}
	//else {
		//cout << "Command didn't changed!" << endl;
	//}
	return result;
}

// getCommandParameters
LIST
CraneI::getCommandParameters(const ::Ice::Current&) {
	return Server::_CommandParameters;
}

// setCommandChanged
void
CraneI::setCommandChanged(const bool value, const ::Ice::Current&) {
	Server::_commandChanged = value;
}

// setStateObjects
void CraneI::setStateObjects(const LIST& objects, const ::Ice::Current&) {
	cout << "setStateObjects - test!" << endl;
	for(LIST::const_iterator it = objects.begin(); it != objects.end(); ++it) {
		Server::_state.addObject(*it);
	}
	return;
}

// setStatePropertiesPerObject
void CraneI::setStatePropertiesPerObject(const string& object, const LIST& properties, const Ice::Current&) {
	cout << "setStatePropertiesPerObject - test!" << endl;
	for(LIST::const_iterator it = properties.begin(); it != properties.end(); ++it) {
		Server::_state.addProperty(object,(*it));
	}
}

// setStateRelation
void CraneI::setStateRelation(const string& relationFrom, const string& relationTo, const string& relation, const ::Ice::Current&) {
	cout << "setStateRelation - test!" << endl;
	Server::_state.addRelation(relationFrom,relationTo,relation);
	return;
};

// getStateObjects
LIST
CraneI::getStateObjects(const ::Ice::Current&) {
	return Server::_state.getObjects();
}

// getStatePropertiesPerObject
LIST
CraneI::getStatePropertiesPerObject(const string& object, const ::Ice::Current&) {
	return Server::_state.getPropertiesOf(object);
}

// getRelationsFrom
LIST
CraneI::getRelationsFrom(const string& object, const ::Ice::Current&) {
	return Server::_state.getRelationsFrom(object);
}

// getRelatedObjects
LIST
CraneI::getRelatedObjects(const string& object, const string& relation, const ::Ice::Current&) {
	return Server::_state.getRelatedObjects(object, relation);
}

