// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `CCU_v1.ice'

#include <CCU_v1.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __CCU__Crane__setCommand_name = "setCommand";

static const ::std::string __CCU__Crane__setState_name = "setState";

::Ice::Object* IceInternal::upCast(::CCU::Obj* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::CCU::Obj* p) { return p; }

::Ice::Object* IceInternal::upCast(::CCU::State* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::CCU::State* p) { return p; }

::Ice::Object* IceInternal::upCast(::CCU::Command* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::CCU::Command* p) { return p; }

::Ice::Object* IceInternal::upCast(::CCU::Crane* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::CCU::Crane* p) { return p; }

void
CCU::__read(::IceInternal::BasicStream* __is, ::CCU::ObjPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::CCU::Obj;
        v->__copyFrom(proxy);
    }
}

void
CCU::__read(::IceInternal::BasicStream* __is, ::CCU::StatePrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::CCU::State;
        v->__copyFrom(proxy);
    }
}

void
CCU::__read(::IceInternal::BasicStream* __is, ::CCU::CommandPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::CCU::Command;
        v->__copyFrom(proxy);
    }
}

void
CCU::__read(::IceInternal::BasicStream* __is, ::CCU::CranePrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::CCU::Crane;
        v->__copyFrom(proxy);
    }
}

void
CCU::__writeSTRINGVECTOR(::IceInternal::BasicStream* __os, const ::CCU::STRINGVECTOR& v)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(v.size());
    __os->writeSize(size);
    for(STRINGVECTOR::const_iterator p = v.begin(); p != v.end(); ++p)
    {
        __os->write((*p));
    }
}

void
CCU::__readSTRINGVECTOR(::IceInternal::BasicStream* __is, ::CCU::STRINGVECTOR& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    STRINGVECTOR(sz).swap(v);
    __is->startSeq(sz, 1);
    for(STRINGVECTOR::iterator p = v.begin(); p != v.end(); ++p)
    {
        __is->read((*p));
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

void
CCU::__writeLIST(::IceInternal::BasicStream* __os, const ::CCU::LIST& v)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(v.size());
    __os->writeSize(size);
    for(LIST::const_iterator p = v.begin(); p != v.end(); ++p)
    {
        __os->write((*p));
    }
}

void
CCU::__readLIST(::IceInternal::BasicStream* __is, ::CCU::LIST& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    LIST(sz).swap(v);
    __is->startSeq(sz, 1);
    for(LIST::iterator p = v.begin(); p != v.end(); ++p)
    {
        __is->read((*p));
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

void
CCU::__writeMAP(::IceInternal::BasicStream* __os, const ::CCU::MAP& v)
{
    __os->writeSize(::Ice::Int(v.size()));
    ::CCU::MAP::const_iterator p;
    for(p = v.begin(); p != v.end(); ++p)
    {
        __os->write(p->first);
        __os->write(::Ice::ObjectPtr(::IceInternal::upCast(p->second.get())));
    }
}

void
CCU::__readMAP(::IceInternal::BasicStream* __is, ::CCU::MAP& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    while(sz--)
    {
        ::std::pair<const  ::std::string, ::CCU::ObjPtr> pair;
        __is->read(const_cast< ::std::string&>(pair.first));
        ::CCU::MAP::iterator __i = v.insert(v.end(), pair);
        __is->read(::CCU::__patch__ObjPtr, &__i->second);
    }
}

const ::std::string&
IceProxy::CCU::Obj::ice_staticId()
{
    return ::CCU::Obj::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::CCU::Obj::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::CCU::Obj);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::CCU::Obj::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::CCU::Obj);
}

::IceProxy::Ice::Object*
IceProxy::CCU::Obj::__newInstance() const
{
    return new Obj;
}

const ::std::string&
IceProxy::CCU::State::ice_staticId()
{
    return ::CCU::State::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::CCU::State::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::CCU::State);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::CCU::State::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::CCU::State);
}

::IceProxy::Ice::Object*
IceProxy::CCU::State::__newInstance() const
{
    return new State;
}

const ::std::string&
IceProxy::CCU::Command::ice_staticId()
{
    return ::CCU::Command::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::CCU::Command::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::CCU::Command);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::CCU::Command::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::CCU::Command);
}

::IceProxy::Ice::Object*
IceProxy::CCU::Command::__newInstance() const
{
    return new Command;
}

void
IceProxy::CCU::Crane::setCommand(const ::CCU::CommandPtr& c, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::CCU::Crane* __del = dynamic_cast< ::IceDelegate::CCU::Crane*>(__delBase.get());
            __del->setCommand(c, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::CCU::Crane::setState(const ::CCU::StatePtr& s, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::CCU::Crane* __del = dynamic_cast< ::IceDelegate::CCU::Crane*>(__delBase.get());
            __del->setState(s, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::CCU::Crane::ice_staticId()
{
    return ::CCU::Crane::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::CCU::Crane::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::CCU::Crane);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::CCU::Crane::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::CCU::Crane);
}

::IceProxy::Ice::Object*
IceProxy::CCU::Crane::__newInstance() const
{
    return new Crane;
}

void
IceDelegateM::CCU::Crane::setCommand(const ::CCU::CommandPtr& c, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __CCU__Crane__setCommand_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(::Ice::ObjectPtr(::IceInternal::upCast(c.get())));
        __os->writePendingObjects();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::CCU::Crane::setState(const ::CCU::StatePtr& s, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __CCU__Crane__setState_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(::Ice::ObjectPtr(::IceInternal::upCast(s.get())));
        __os->writePendingObjects();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateD::CCU::Crane::setCommand(const ::CCU::CommandPtr& c, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::CCU::CommandPtr& c, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_c(c)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::CCU::Crane* servant = dynamic_cast< ::CCU::Crane*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->setCommand(_m_c, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::CCU::CommandPtr& _m_c;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __CCU__Crane__setCommand_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(c, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::CCU::Crane::setState(const ::CCU::StatePtr& s, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::CCU::StatePtr& s, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_s(s)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::CCU::Crane* servant = dynamic_cast< ::CCU::Crane*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->setState(_m_s, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::CCU::StatePtr& _m_s;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __CCU__Crane__setState_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(s, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

CCU::Obj::Obj(const ::std::string& __ice_name, const ::CCU::STRINGVECTOR& __ice_relations) :
    name(__ice_name),
    relations(__ice_relations)
{
}

::Ice::ObjectPtr
CCU::Obj::ice_clone() const
{
    ::CCU::ObjPtr __p = new ::CCU::Obj(*this);
    return __p;
}

static const ::std::string __CCU__Obj_ids[2] =
{
    "::CCU::Obj",
    "::Ice::Object"
};

bool
CCU::Obj::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__CCU__Obj_ids, __CCU__Obj_ids + 2, _s);
}

::std::vector< ::std::string>
CCU::Obj::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__CCU__Obj_ids[0], &__CCU__Obj_ids[2]);
}

const ::std::string&
CCU::Obj::ice_id(const ::Ice::Current&) const
{
    return __CCU__Obj_ids[0];
}

const ::std::string&
CCU::Obj::ice_staticId()
{
    return __CCU__Obj_ids[0];
}

void
CCU::Obj::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->write(name);
    ::CCU::__writeSTRINGVECTOR(__os, relations);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
CCU::Obj::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->read(name);
    ::CCU::__readSTRINGVECTOR(__is, relations);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
CCU::Obj::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type CCU::Obj was not generated with stream support";
    throw ex;
}

void
CCU::Obj::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type CCU::Obj was not generated with stream support";
    throw ex;
}

class __F__CCU__Obj : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::CCU::Obj::ice_staticId());
        return new ::CCU::Obj;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__CCU__Obj_Ptr = new __F__CCU__Obj;

const ::Ice::ObjectFactoryPtr&
CCU::Obj::ice_factory()
{
    return __F__CCU__Obj_Ptr;
}

class __F__CCU__Obj__Init
{
public:

    __F__CCU__Obj__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::CCU::Obj::ice_staticId(), ::CCU::Obj::ice_factory());
    }

    ~__F__CCU__Obj__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::CCU::Obj::ice_staticId());
    }
};

static __F__CCU__Obj__Init __F__CCU__Obj__i;

#ifdef __APPLE__
extern "C" { void __F__CCU__Obj__initializer() {} }
#endif

void 
CCU::__patch__ObjPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::CCU::ObjPtr* p = static_cast< ::CCU::ObjPtr*>(__addr);
    assert(p);
    *p = ::CCU::ObjPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::CCU::Obj::ice_staticId(), v->ice_id());
    }
}

bool
CCU::operator==(const ::CCU::Obj& l, const ::CCU::Obj& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
CCU::operator<(const ::CCU::Obj& l, const ::CCU::Obj& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

CCU::State::State(const ::CCU::MAP& __ice_objects) :
    objects(__ice_objects)
{
}

::Ice::ObjectPtr
CCU::State::ice_clone() const
{
    ::CCU::StatePtr __p = new ::CCU::State(*this);
    return __p;
}

static const ::std::string __CCU__State_ids[2] =
{
    "::CCU::State",
    "::Ice::Object"
};

bool
CCU::State::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__CCU__State_ids, __CCU__State_ids + 2, _s);
}

::std::vector< ::std::string>
CCU::State::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__CCU__State_ids[0], &__CCU__State_ids[2]);
}

const ::std::string&
CCU::State::ice_id(const ::Ice::Current&) const
{
    return __CCU__State_ids[0];
}

const ::std::string&
CCU::State::ice_staticId()
{
    return __CCU__State_ids[0];
}

void
CCU::State::__incRef()
{
    __gcIncRef();
}

void
CCU::State::__decRef()
{
    __gcDecRef();
}

void
CCU::State::__addObject(::IceInternal::GCCountMap& _c)
{
    ::IceInternal::GCCountMap::iterator pos = _c.find(this);
    if(pos == _c.end())
    {
        _c[this] = 1;
    }
    else
    {
        ++pos->second;
    }
}

bool
CCU::State::__usesClasses()
{
    return true;
}

void
CCU::State::__gcReachable(::IceInternal::GCCountMap& _c) const
{
    {
        for(::CCU::MAP::const_iterator _i0 = objects.begin(); _i0 != objects.end(); ++_i0)
        {
            if((*_i0).second)
            {
                ::IceInternal::upCast((*_i0).second.get())->__addObject(_c);
            }
        }
    }
}

void
CCU::State::__gcClear()
{
    {
        for(::CCU::MAP::iterator _i0 = objects.begin(); _i0 != objects.end(); ++_i0)
        {
            if((*_i0).second)
            {
                if(::IceInternal::upCast((*_i0).second.get())->__usesClasses())
                {
                    ::IceInternal::upCast((*_i0).second.get())->__decRefUnsafe();
                    (*_i0).second.__clearHandleUnsafe();
                }
                else
                {
                    (*_i0).second = 0;
                }
            }
        }
    }
}

void
CCU::State::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    ::CCU::__writeMAP(__os, objects);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
CCU::State::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    ::CCU::__readMAP(__is, objects);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
CCU::State::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type CCU::State was not generated with stream support";
    throw ex;
}

void
CCU::State::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type CCU::State was not generated with stream support";
    throw ex;
}

class __F__CCU__State : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::CCU::State::ice_staticId());
        return new ::CCU::State;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__CCU__State_Ptr = new __F__CCU__State;

const ::Ice::ObjectFactoryPtr&
CCU::State::ice_factory()
{
    return __F__CCU__State_Ptr;
}

class __F__CCU__State__Init
{
public:

    __F__CCU__State__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::CCU::State::ice_staticId(), ::CCU::State::ice_factory());
    }

    ~__F__CCU__State__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::CCU::State::ice_staticId());
    }
};

static __F__CCU__State__Init __F__CCU__State__i;

#ifdef __APPLE__
extern "C" { void __F__CCU__State__initializer() {} }
#endif

void 
CCU::__patch__StatePtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::CCU::StatePtr* p = static_cast< ::CCU::StatePtr*>(__addr);
    assert(p);
    *p = ::CCU::StatePtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::CCU::State::ice_staticId(), v->ice_id());
    }
}

bool
CCU::operator==(const ::CCU::State& l, const ::CCU::State& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
CCU::operator<(const ::CCU::State& l, const ::CCU::State& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

CCU::Command::Command(const ::std::string& __ice_name, const ::CCU::LIST& __ice_parameters) :
    name(__ice_name),
    parameters(__ice_parameters)
{
}

::Ice::ObjectPtr
CCU::Command::ice_clone() const
{
    ::CCU::CommandPtr __p = new ::CCU::Command(*this);
    return __p;
}

static const ::std::string __CCU__Command_ids[2] =
{
    "::CCU::Command",
    "::Ice::Object"
};

bool
CCU::Command::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__CCU__Command_ids, __CCU__Command_ids + 2, _s);
}

::std::vector< ::std::string>
CCU::Command::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__CCU__Command_ids[0], &__CCU__Command_ids[2]);
}

const ::std::string&
CCU::Command::ice_id(const ::Ice::Current&) const
{
    return __CCU__Command_ids[0];
}

const ::std::string&
CCU::Command::ice_staticId()
{
    return __CCU__Command_ids[0];
}

void
CCU::Command::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->write(name);
    ::CCU::__writeLIST(__os, parameters);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
CCU::Command::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->read(name);
    ::CCU::__readLIST(__is, parameters);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
CCU::Command::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type CCU::Command was not generated with stream support";
    throw ex;
}

void
CCU::Command::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type CCU::Command was not generated with stream support";
    throw ex;
}

class __F__CCU__Command : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::CCU::Command::ice_staticId());
        return new ::CCU::Command;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__CCU__Command_Ptr = new __F__CCU__Command;

const ::Ice::ObjectFactoryPtr&
CCU::Command::ice_factory()
{
    return __F__CCU__Command_Ptr;
}

class __F__CCU__Command__Init
{
public:

    __F__CCU__Command__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::CCU::Command::ice_staticId(), ::CCU::Command::ice_factory());
    }

    ~__F__CCU__Command__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::CCU::Command::ice_staticId());
    }
};

static __F__CCU__Command__Init __F__CCU__Command__i;

#ifdef __APPLE__
extern "C" { void __F__CCU__Command__initializer() {} }
#endif

void 
CCU::__patch__CommandPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::CCU::CommandPtr* p = static_cast< ::CCU::CommandPtr*>(__addr);
    assert(p);
    *p = ::CCU::CommandPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::CCU::Command::ice_staticId(), v->ice_id());
    }
}

bool
CCU::operator==(const ::CCU::Command& l, const ::CCU::Command& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
CCU::operator<(const ::CCU::Command& l, const ::CCU::Command& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
CCU::Crane::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __CCU__Crane_ids[2] =
{
    "::CCU::Crane",
    "::Ice::Object"
};

bool
CCU::Crane::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__CCU__Crane_ids, __CCU__Crane_ids + 2, _s);
}

::std::vector< ::std::string>
CCU::Crane::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__CCU__Crane_ids[0], &__CCU__Crane_ids[2]);
}

const ::std::string&
CCU::Crane::ice_id(const ::Ice::Current&) const
{
    return __CCU__Crane_ids[0];
}

const ::std::string&
CCU::Crane::ice_staticId()
{
    return __CCU__Crane_ids[0];
}

::Ice::DispatchStatus
CCU::Crane::___setCommand(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::CCU::CommandPtr c;
    __is->read(::CCU::__patch__CommandPtr, &c);
    __is->readPendingObjects();
    __is->endReadEncaps();
    setCommand(c, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
CCU::Crane::___setState(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::CCU::StatePtr s;
    __is->read(::CCU::__patch__StatePtr, &s);
    __is->readPendingObjects();
    __is->endReadEncaps();
    setState(s, __current);
    return ::Ice::DispatchOK;
}

static ::std::string __CCU__Crane_all[] =
{
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "setCommand",
    "setState"
};

::Ice::DispatchStatus
CCU::Crane::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__CCU__Crane_all, __CCU__Crane_all + 6, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __CCU__Crane_all)
    {
        case 0:
        {
            return ___ice_id(in, current);
        }
        case 1:
        {
            return ___ice_ids(in, current);
        }
        case 2:
        {
            return ___ice_isA(in, current);
        }
        case 3:
        {
            return ___ice_ping(in, current);
        }
        case 4:
        {
            return ___setCommand(in, current);
        }
        case 5:
        {
            return ___setState(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
CCU::Crane::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
CCU::Crane::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
CCU::Crane::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type CCU::Crane was not generated with stream support";
    throw ex;
}

void
CCU::Crane::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type CCU::Crane was not generated with stream support";
    throw ex;
}

void 
CCU::__patch__CranePtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::CCU::CranePtr* p = static_cast< ::CCU::CranePtr*>(__addr);
    assert(p);
    *p = ::CCU::CranePtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::CCU::Crane::ice_staticId(), v->ice_id());
    }
}

bool
CCU::operator==(const ::CCU::Crane& l, const ::CCU::Crane& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
CCU::operator<(const ::CCU::Crane& l, const ::CCU::Crane& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}
