[["cpp:include:list"]]
module CCU {
       ["cpp:type:std::list<std::string>"] sequence<string> LIST;
       ["cpp:type:std::vector<std::string>"] sequence<string> VECTOR;
       
       interface Crane {
       		 // Command
       		 ["ami","amd"] void setCommand(string name,LIST parameter);
       		 LIST getCommandParameters();
       		 string getCommandName();
       		 void setCommandChanged(bool value);
       		 // State
       		 void setStateObjects(LIST objects);
       		 void setStatePropertiesPerObject(string obj, LIST properties);
		     void setStateRelation(string relationFrom, string relationTo, string relation);
		     LIST getStateObjects();
		     LIST getStatePropertiesPerObject(string obj);
		     LIST getRelationsFrom(string obj);
		     LIST getRelatedObjects(string obj, string relation);
       };
};